unit Adsorb;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Spin, Grids, TeeProcs, TeEngine, Chart,
  Series;

type

  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    ctl_ExCount: TSpinEdit;
    lbl_Info1: TLabel;
    ctl_XSize: TSpinEdit;
    lbl_Info2: TLabel;
    ctl_YSize: TSpinEdit;
    lbl_Info3: TLabel;
    ctl_SPP: TSpinEdit;
    Label1: TLabel;
    ctl_EPP: TSpinEdit;
    Label2: TLabel;
    ctl_PPStep: TSpinEdit;
    Label3: TLabel;
    ctl_Freg: TEdit;
    Label4: TLabel;
    ctl_Temp: TEdit;
    Label5: TLabel;
    ctl_MMass: TEdit;
    Label6: TLabel;
    ctl_MS: TEdit;
    Label7: TLabel;
    btn_Start: TButton;
    GroupBox2: TGroupBox;
    ctl_Image: TPaintBox;
    Label8: TLabel;
    ctl_Zoom: TSpinEdit;
    Label9: TLabel;
    ctl_TImeStep: TSpinEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    ST: TSpinEdit;
    ET: TSpinEdit;
    TStep: TSpinEdit;
    Chart2: TChart;
    Series2: TLineSeries;
    Label10: TLabel;
    U_a: TEdit;
    procedure btn_StartClick(Sender: TObject);
    procedure ctl_ImagePaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
  private
    ANowProcces: Boolean;
    resultsList, paramersList: TStringList;
    ctl_Data: Array[0..1000, 0..1000] Of Char;
    zoomVal: Integer;
    pe: Extended; {Equilibrium pressure}
    dUKT: Extended;
    tmpSQ1: Extended; {sqrt(2*Pi*m*K*T}
    KT: Extended;
    Function MakeBasesP(Acurrentp: Extended): Extended;
    Function MakeBasesT(AcurrentT: Extended): Extended;
    Procedure DrawPolegon;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TimerSync: boolean; {Nick_N_A}


implementation

{$R *.DFM}
Uses
  Math;


{------------------------------------------------------------------------------}

Procedure TForm1.DrawPolegon;
Var
  i, n, c: Integer;
  x, y: Integer;
Begin

  For i:= 1 To  ctl_YSize.Value Do {x}
    For n:= 1 To  ctl_XSize.Value Do {y}
      Begin
        If (ctl_Data[n, i] = '') Or (ctl_Data[n, i] = '0')  Then c:= clYellow
        Else c:= clRed;

        If ctl_Image.Canvas.Pixels[n * zoomVal, i * zoomVal] <> c Then
          Begin
            ctl_Image.Canvas.Pixels[n * zoomVal, i * zoomVal]:= c;


            If zoomVal > 1 Then
              For y:= 0 To zoomVal - 1 Do
                Begin
                  For x:= 0 To zoomVal - 1 Do
                    Begin
                      ctl_Image.Canvas.Pixels[n * zoomVal + x, i * zoomVal + y]:= c;
                    End;
                End;
            End;
          End;
End;
{------------------------------------------------------------------------------}

Function TForm1.MakeBasesP(Acurrentp: Extended): Extended;
Var
  tmpExp: Integer; {The number of trials}
  X, Y: Integer; {The place of trial}
  t_os{The time of deposition},  
  RandomP,    
  t_isp{The time of evaporation},
  ver_os{Probability of deposition},
  ver_isp{Probability of evaporation}: Extended;
  n_osevshih: LongInt; {The number of deposited molecules}
Label
  5;

Begin  
  n_osevshih:= 0;
  {Calculation of variables}
   t_os:=tmpSQ1/(Acurrentp*StrToFloat(ctl_MS.Text));   {The time of deposition}
   t_isp:=Exp(dUKT)/StrToFloat(ctl_Freg.Text);	{The time of evaporation}
   ver_isp:=t_os/t_isp; //ver_os    {Probability of evaporation}
   ver_os:=t_isp/t_os;    {Probability of deposition}
  
  For tmpExp:= 1 To ctl_ExCount.Value Do

    Begin    
      X:= Random(ctl_XSize.Value)+1;
      Y:= Random(ctl_YSize.Value)+1;
      RandomP:= Random;

      If Acurrentp >= pe Then       //P, Pe
        Begin
          If (ctl_Data[X, Y] = '') Or
             (ctl_Data[X, Y] = '0') Then    {'0' '' -- 1}
          Begin                                             {'1' -- 2}
            ctl_Data[X, Y]:= '1';
            Inc(n_osevshih);  {The number of deposited molecules}
            goto 5;
          End;


      If (ctl_Data[X, Y] = '1') And
         (ver_isp > RandomP) Then
      Begin
        ctl_Data[X, Y]:= '0';
        Dec(n_osevshih);
      End;

      End; {pp>=pe}

      If Acurrentp < pe Then
        Begin
          If ((ctl_Data[X, Y] = '') Or
             (ctl_Data[X, Y] = '0')) And (ver_os >= RandomP) Then
          Begin
            ctl_Data[X, Y]:= '1';
            Inc(n_osevshih);
            goto 5;
          End;


      If (ctl_Data[X, Y] = '1') Then  //type[x,y]
      Begin
        ctl_Data[X, Y]:= '0';
        Dec(n_osevshih);
      End;

       End; {pp<pe}

    5:End;

  Result:= n_osevshih / ((ctl_XSize.Value) * ctl_YSize.Value);   {The part of deposited moleculs}
 End;
{------------------------------------------------------------------------------}

Function TForm1.MakeBasesT(AcurrentT: Extended): Extended;
Var
  tmpExp: Integer; {The number of trials}
  X, Y: Integer; {The place of trial}
  t_os               {The time of deposition},
  RandomP,
  t_isp	       {The time of evaporation},
  ver_os               {Probability of deposition},
  ver_isp	         {Probability of evaporation}: Extended;
  n_osevshih: LongInt; {The number of deposited molecules}
  currentp: Extended;  {Pressure}
Label
  5;
Begin
  currentp:=strtofloat(ctl_Temp.Text);
  KT:=AcurrentT*1.38e-23;
  dUKT:=strtofloat(U_a.Text)/KT;   {The activation energy in kT units}  
  tmpSQ1:= sqrt(StrToFloat(ctl_MMass.Text)/6e23) * {(m)^(1/2)}
             sqrt(6.283 * KT);

  pe:= StrToFloat(ctl_Freg.Text) * {}
                Exp(-1 * dUKT) * {e^(-dUKT)}
                tmpSQ1 / StrToFloat(ctl_MS.Text);


  n_osevshih:= 0;
  {Calculation of variables}
   t_os:=tmpSQ1/(strtofloat(ctl_Temp.Text)*StrToFloat(ctl_MS.Text));
   t_isp:=Exp(dUKT)/StrToFloat(ctl_Freg.Text);
   ver_isp:=t_os/t_isp;
   ver_os:=t_isp/t_os;

  For tmpExp:= 1 To ctl_ExCount.Value Do
    Begin
 
      X:= Random(ctl_XSize.Value)+1;
      Y:= Random(ctl_YSize.Value)+1;
      RandomP:= Random;

      If currentp >= pe Then
        Begin
          If (ctl_Data[X, Y] = '') Or
             (ctl_Data[X, Y] = '0') Then    {'0' '' -- 1}
          Begin                                             {'1' -- 2}
            ctl_Data[X, Y]:= '1';
            Inc(n_osevshih);
            goto 5;
          End;


      If (ctl_Data[X, Y] = '1') And
         (ver_isp > RandomP) Then
      Begin
        ctl_Data[X, Y]:= '0';
        Dec(n_osevshih);
      End;

      End; {pp>=pe}

      If currentp < pe Then
        Begin
          If ((ctl_Data[X, Y] = '') Or
             (ctl_Data[X, Y] = '0')) And (ver_os >= RandomP) Then
          Begin
            ctl_Data[X, Y]:= '1';
            Inc(n_osevshih);
            goto 5;
          End;


      If (ctl_Data[X, Y] = '1') Then
      Begin
        ctl_Data[X, Y]:= '0';
        Dec(n_osevshih);
      End;

       End; {pp<pe}

5:End;
   Result:= n_osevshih / ((ctl_XSize.Value) * ctl_YSize.Value);  {The part of deposited moleculs}
 End;
{------------------------------------------------------------------------------}

procedure TForm1.btn_StartClick(Sender: TObject);
Var
  currentp: Extended; {Current pressure}
  currentT: Extended; {Temperature}
  CurrentK: Extended; {For graph and picture}

  i, n: Integer;
Begin
  ctl_Image.Canvas.Refresh;


  Timer1.Interval:= ctl_TImeStep.Value;

  zoomVal:= ctl_Zoom.Value;
  Randomize;
  ANowProcces:= True;
  Try
    btn_Start.Enabled:= False;

  if (RadioButton1.Checked = True) then
  BEGIN
    {Izoterma}
    Chart1.BottomAxis.Maximum:=Power(10, ctl_EPP.Value);
    Chart1.BottomAxis.Minimum:=Power(10, ctl_SPP.Value);
    KT:=strtofloat(ctl_Temp.Text)*1.38e-23;
    dUKT:=strtofloat(U_a.Text)/KT;
    tmpSQ1:= sqrt(StrToFloat(ctl_MMass.Text)/6e23) * {(m)^(1/2)}
             sqrt(6.283 * KT);

    pe:= StrToFloat(ctl_Freg.Text) * 
                Exp(-1 * dUKT) * {e^(-dUKT)}
                tmpSQ1 / StrToFloat(ctl_MS.Text);

    currentp:= Power(10, ctl_SPP.Value);
    Series1.Clear;
    While currentp <= Power(10, ctl_EPP.Value) Do
      Begin
        TimerSync := false; {Nick_N_A}
       
        For i:= 1 To ctl_YSize.Value Do
          For n:= 1 To ctl_XSize.Value Do
            ctl_Data[n, i]:= '0';

        CurrentK:= MakeBasesP(currentp);
        DrawPolegon;
        Series1.AddXY(currentp, CurrentK, '', clRed);
        currentp:= currentp * ctl_PPStep.Value;

        while not TimerSync do Begin
          WaitMessage;
          Application.ProcessMessages;
        end;
       End;
   END
   else
   BEGIN

     {Izobara}
   currentT:=ST.Value;
    Chart2.BottomAxis.Maximum:=ET.Value;
    Chart2.BottomAxis.Minimum:=ST.Value;

    currentp:= strtofloat(ctl_Temp.Text);
    Series2.Clear;
    While currentT <= ET.Value Do
      Begin
        TimerSync := false; {Nick_N_A}

        For i:= 1 To ctl_YSize.Value Do
          For n:= 1 To ctl_XSize.Value Do
            ctl_Data[n, i]:= '0';

        CurrentK:= MakeBasesT(currentT);
        DrawPolegon;
        Series2.AddXY(currentT, CurrentK, '', clGreen);
        currentT:= currentT + TStep.Value;

        while not TimerSync do Begin
          WaitMessage;
          Application.ProcessMessages;
        end;
       End;

   END;



  Finally
    btn_Start.Enabled:= True;
    ANowProcces:= False;

  End;
End;
{------------------------------------------------------------------------------}

procedure TForm1.ctl_ImagePaint(Sender: TObject);
begin

  DrawPolegon;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
Begin

TimerSync := true;

End;

procedure TForm1.FormShow(Sender: TObject);
Begin
  ANowProcces:= False;
End;
{------------------------------------------------------------------------------}

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
ctl_SPP.Visible:=true;
ctl_EPP.Visible:=true;
ctl_PPStep.Visible:=true;
St.Visible:=false;
Et.Visible:=false;
TStep.Visible:=false;
ctl_SPP.Value:=0;
ctl_EPP.Value:=6;
ctl_PPStep.Value:=10;
ctl_Temp.Text:='385';
Label1.Caption:='Initial pressure (10^):';
Label2.Caption:='Final  (10^):';
Label3.Caption:='Factor of multiplying:';
Label5.Caption:='Temperature():';
Chart1.Visible:=True;
Chart2.Visible:=False;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
ctl_SPP.Visible:=false;
ctl_EPP.Visible:=false;
ctl_PPStep.Visible:=false;
St.Visible:=true;
Et.Visible:=true;
TStep.Visible:=true;
ST.Value:=150;
ET.Value:=390;
TStep.Value:=40;
ctl_Temp.Text:='1000';
Label1.Caption:='Initial temperature ():';
Label2.Caption:='Final temperature ():';
Label3.Caption:='Step in temperature:';
Label5.Caption:='Pressure (Pa):';
Chart2.Visible:=True;
Chart1.Visible:=False;
end;

end.

