unit cryst_u;

interface

uses
  Classes,SysUtils,FileCtrl,graphics,Dialogs;

const www=30;

type
  Tcluster=array[0..4] of integer;
  TFCryst= record map:array [0..200,0..200] of byte;
                  size:record x,y:byte; end;
                  time,avbtime,avbrate:cardinal;
                  shrate:longint;
                  fx,fy,fz,dm,dh:real;
           end;

  TCryst = class(TThread)
    randar,arr:array [0..200*200*2] of record x,y,z:byte; end; { . }
    fx,fy,fz,dm,dh:real; {entropy of melting and relative supersaturation dm/kT}
    time:cardinal; 
    avbtime,avbrate:cardinal;  {point of time for averaging}
    shrate:longint;  { }
    map:array [0..200,0..200] of byte; {the size of crystal plane}
{}    avmap:array[0..200] of real;
    periods:integer;        
    size:record x,y:byte; end;  {type of variables}
    veri:array [0..2,0..2] of real;  {Probabilities of detaching }
    verp:real;                       {Probability of attaching }
    canv:Tcanvas;      {s:string;}
    vis:record paleter:array [0..15] of tcolor;
               x:integer;
        end;
    PF1,PF2,PF3,PF4:text;   {the cluster size, lenght of outline, the numbers of atoms with 1 2 3 4 broken bonds, roughness}
    BegPrF:longint;
    ProtWr:boolean;
  private
  protected
    procedure Execute; override;
  public
    constructor create;
{}    procedure avaragemap; {make the averaged outline}
    procedure Save;     
    procedure Load(s:string);    
    procedure ShutDown;  {averaging again}
    function Rate:cardinal; {the crystal volume}
    procedure Restore_L(n:integer); {+- n changes the number of layers}
    procedure Recount;  {calculates probabilities}
    procedure PrepearCr; {an initial crystal}
    procedure cluster(n:longint; var cl:Tcluster);  {parameters of maximum cluster}
    procedure show;  {view from above}
{}    procedure showf; {side view}
    procedure PrepProt; {preparing of protocols}
    procedure CloseProt; {closing of protocol files}
    procedure ProtWrit; {writting down into protocl files}
    function max:longint;
    procedure shuffle;
    function sherohov:real;
  end;

implementation

{ Cryst }

{} var ttp:cardinal;

{}procedure Tcryst.showf;
  var i,j,k,x,x1,x2,y1,y2:integer;
  begin
    k:=size.y div 2 -1;
    canv.Lock;
    canv.Brush.Color:=clwhite;
    canv.FillRect(rect(1,1,1000,1000));
    canv.Brush.color:=clblack;
    for i:=1 to size.x-2 do
      for j:=1 to map[i,k]  do begin
        x1:=i*vis.x; x2:=x1+vis.x+1;
        y1:=j*vis.x; y2:=y1+vis.x+1;
        canv. FrameRect(rect(x1,y1,x2,y2));
      end;
    x:=vis.x div 2;
    canv.pen.color:=clBlack;
    canv.pen.Width:=2;
    canv.MoveTo(vis.x+x,round(avmap[1]*vis.x));
    for i:=2 to size.x-2 do
      canv.LineTo(i*vis.x+x,round(vis.x*avmap[i]+x));
    canv.unLock;
  end;

{}procedure Tcryst.avaragemap;
  var i,j:byte; s1:integer; sa,d:real; tt:cardinal;
  begin
    j:=size.y div 2 -1;
    s1:=0; sa:=0;
    tt:=time-avbtime;
    for i:=1 to size.x-2 do s1:=s1+map[i,j];
    for i:=1 to size.x-2 do sa:=sa+avmap[i];
    d:=(s1-sa)/(size.x-2);
    if tt>0 then
      for i:=1 to size.x-2 do avmap[i]:=(avmap[i]*ttp+(tt-ttp)*map[i,j])/tt+d;
    ttp:=tt;
  end;

function Tcryst.sherohov:real;
  var i,j,x1,x2,y1,y2:byte; s:integer;
  begin
    s:=0;
    x1:=size.x div 2 - size.x div 4; x2:=size.x div 2 + size.x div 4;
    y1:=size.y div 2 - size.y div 4; y2:=size.y div 2 + size.y div 4;
      for i:=x1 to x2 do
        for j:= y1 to y2 do
          s:=s+abs(map[i,j]-map[i,j-1])+abs(map[i,j]-map[i-1,j]);
    sherohov:=s/(x2-x1+1)/(y2-y1+1);
end;

procedure Tcryst.shuffle;
  var i,j,n:integer; x,y,z:byte;
  begin
    n:=(size.x-2)*(size.y-2)*2;
    for i:=0 to n-1 do begin
      randar[i].x:=arr[i].x; randar[i].y:=arr[i].y; randar[i].z:=arr[i].z;
    end;
    for i:=0 to n-1 do begin
      j:=random(n-i)+i;
      x:=randar[i].x; y:=randar[i].y; z:=randar[i].z;
      randar[i].x:=randar[j].x; randar[i].y:=randar[j].y; randar[i].z:=randar[j].z;
      randar[j].x:=x; randar[j].y:=y; randar[j].z:=z;
    end;
  end;

function Tcryst.max:longint;
  var z,i,j:byte;
  begin
    z:=0;
    for i:=1 to size.x-2 do
      for j:=1 to size.y-2 do
        if z<map[i,j] then z:=map[i,j];
    max:=z+shrate;
  end;

procedure TCryst.PrepProt;
  var s,sf,sdm,sx,sy:string;
  begin
    sf:='('+floattostr(fx)+','+floattostr(fy)+','+floattostr(fz)+')';
    sdm:=floattostr(dm);
    sx:=inttostr(size.x); sy:=inttostr(size.y);
    s:='D:\Crystals\f='+sf+'_dm='+sdm+'_'+sx+'x'+sy;
    ForceDirectories(s);
    assignfile(PF1,s+'\area.cpr');
    assignfile(PF2,s+'\length.cpr');
    assignfile(PF3,s+'\izlom.cpr');
    assignfile(PF4,s+'\sheroh.cpr');
    rewrite(PF1); rewrite(PF2); rewrite(PF3); rewrite(PF4);
    ProtWr:=true;
  end;

procedure TCryst.CloseProt;
  begin
    closefile(PF1); closefile(PF2); closefile(PF3); closefile(PF4);
    protwr:=false;
  end;

procedure Tcryst. ProtWrit;
  var s1,s2,s3,st:string;
      i:byte; n,l:integer;
      cl:Tcluster;
  begin
    st:=floattostr(time*1e-13*exp(fz/3));
    s1:=st;
    s2:=st;
    s3:=st;
    for i:=1 to 20 do begin
      cluster(i+BegPrF,cl);
      n:=cl[0]+cl[1]+cl[2]+cl[3]+cl[4];
      l:=cl[1]+2*cl[2]+3*cl[3]+cl[4]*4;
      s1:=s1+'|'+inttostr(n);
      s2:=s2+'|'+inttostr(l);
      s3:=s3+'|'+inttostr(cl[1])+'*'+inttostr(cl[2])+'*'+inttostr(cl[3]);
    end;
    writeln(pf1,s1); writeln(pf2,s2); writeln(pf3,s3);
    s1:=st+'|'+floattostr(sherohov);
    writeln(pf4,s1);
  end;

procedure TCryst.cluster(n:longint; var cl:Tcluster);
var dmap:array [0..200,0..200] of byte;
    i,j:byte;
    nnn:array [0..4] of integer;

  procedure recurs1(x,y:byte);
    begin
      dmap[x,y]:=2;
      if dmap[x-1,y]=0 then recurs1(x-1,y);
      if dmap[x+1,y]=0 then recurs1(x+1,y);
      if dmap[x,y-1]=0 then recurs1(x,y-1);
      if dmap[x,y+1]=0 then recurs1(x,y+1);
    end;

  procedure recurs2(x,y:byte);
    var nn:byte;
    begin
      dmap[x,y]:=2;
      nn:=0;
      if dmap[x+1,y]=0 then inc(nn); if dmap[x-1,y]=0 then inc(nn);
      if dmap[x,y+1]=0 then inc(nn); if dmap[x,y-1]=0 then inc(nn);
      inc(nnn[nn]);
      if dmap[x-1,y]=1 then recurs2(x-1,y);
      if dmap[x+1,y]=1 then recurs2(x+1,y);
      if dmap[x,y-1]=1 then recurs2(x,y-1);
      if dmap[x,y+1]=1 then recurs2(x,y+1);
    end;

var ms,sss:integer; mn:array[0..4] of integer;
begin
  ms:=0;
  n:=n-shrate;
  for i:=1 to size.x-2 do
    for j:=1 to size.y-2 do
      if map[i,j]>=n then dmap[i,j]:=1
      else dmap[i,j]:=0;
  for i:=0 to size.x-1 do begin dmap[i,0]:=1; dmap[i,size.y-1]:=1; end;
  for i:=0 to size.y-1 do begin dmap[0,i]:=1; dmap[size.x-1,i]:=1; end;
  if dmap[1,1]=0 then recurs1(1,1);
  for i:=1 to size.x-2 do
    for j:=1 to size.y-2 do
      if dmap[i,j]=2 then dmap[i,j]:=0
      else if dmap[i,j]=0 then dmap[i,j]:=1;
  for i:=0 to size.x-1 do begin dmap[i,0]:=0; dmap[i,size.y-1]:=0; end;
  for i:=0 to size.y-1 do begin dmap[0,i]:=0; dmap[size.x-1,i]:=0; end;
  mn[0]:=0; mn[1]:=0; mn[2]:=0; mn[3]:=0; mn[4]:=0;
  for i:=1 to size.x-2 do
    for j:=1 to size.y-2 do
      if dmap[i,j]=1 then begin
        nnn[0]:=0; nnn[1]:=0; nnn[2]:=0; nnn[3]:=0; nnn[4]:=0;
        recurs2(i,j);
        sss:=nnn[0]+nnn[1]+nnn[2]+nnn[3]+nnn[4];
        if ms<sss then begin
          mn[0]:=nnn[0]; mn[1]:=nnn[1]; mn[2]:=nnn[2];
          mn[3]:=nnn[3]; mn[4]:=nnn[4]; ms:=sss;
        end;
      end;
  cl[0]:=mn[0]; cl[1]:=mn[1]; cl[2]:=mn[2]; cl[3]:=mn[3]; cl[4]:=mn[4];
end;

constructor TCryst.create;
  begin
    inherited create(true);
    randomize;
    size.x:=42; size.y:=42;
    fx:=1.8; fy:=1.8; fz:=1.8; dm:=0.1;dh:=3.5;
    time:=0; 
    periods:=30;
    vis.x:=4;
    recount;
    PrepearCr;
    ProtWr:=false;
    shutdown;
    with vis do begin
      paleter[0]:=clBlack; paleter[4]:=clRed;
      paleter[1]:=clBlue;  paleter[5]:=clYellow;
      paleter[2]:=clGreen; paleter[6]:=clolive;
      paleter[3]:=clOlive; paleter[7]:=clwhite;
    end;
  end;

procedure Tcryst.Recount;
  var i,j:byte;
  begin
    for i:=0 to 2 do
      for j:=0 to 2 do
        veri[i,j]:=exp(-fz-fx*i-fy*j)*exp(fz);
    verp:=exp(-fz-fx-fy+dm)*exp(fz);
  end;

procedure Tcryst.PrepearCr;
  var i,j:byte; n:cardinal;
  begin
    n:=0;
    for i:=1 to size.x-2 do
      for j:=1 to size.y-2 do begin
        arr[n].x:=i; arr[n].y:=j; arr[n].z:=0;
        arr[n+1].x:=i; arr[n+1].y:=j; arr[n].z:=1;
        inc(n,2);
      end;
    shuffle;
    for i:=0 to size.x-1 do
      for j:=0 to size.y-1 do
        if j < size.y-75 then map[i,j]:=0 else map[i,j]:=1;
    for i:=1 to size.x-2 do
      for j:=1 to size.y-2 do
        //map[i,j]:=www;
         if j < size.y-75 then map[i,j]:=www+2 else map[i,j]:=www+1;
  end;

procedure TCryst.Save;
  var sf,sdm,sx,sy,s:string;
      ff:file of TFCryst;
      cr:TFCryst;
      i,j:byte;
  begin
    sf:='('+floattostr(fx)+','+floattostr(fy)+','+floattostr(fz)+')';
    sdm:=floattostr(dm);
    sx:=inttostr(size.x); sy:=inttostr(size.y);
    s:='D:\Crystals\f='+sf+'_dm='+sdm+'_'+sx+'x'+sy;
    for i:=0 to size.x-1 do
      for j:=0 to size.y-1 do
        cr.map[i,j]:=map[i,j];
    cr.size.x:=size.x; cr.size.y:=size.y; cr.time:=time;
    cr.avbtime:=avbtime; cr.avbrate:=avbrate; cr.shrate:=shrate;
    cr.fx:=fx; cr.fy:=fy; cr.fz:=fz; cr.dm:=dm;
    ForceDirectories(s);
    assign(ff,s+'\main.cry');
    rewrite(ff);
    write(ff,cr);
    close(ff);
  end;

procedure TCryst.Load(s:string);
  var ff:file of TFCryst;
      cr:TFCryst;
      i,j:byte; n:cardinal;
  begin  ForceDirectories(s);
    assign(ff,s);
    reset(ff);
    read(ff,cr);
    close(ff);
    size.x:=cr.size.x; size.y:=cr.size.y; time:=cr.time;
    avbtime:=cr.avbtime; avbrate:=cr.avbrate; shrate:=cr.shrate;
    fx:=cr.fx; fy:=cr.fy; fz:=cr.fz; dm:=cr.dm;
    recount;
    for i:=0 to size.x-1 do
      for j:=0 to size.y-1 do
        map[i,j]:=cr.map[i,j];
    n:=0;
    for i:=1 to size.x-2 do
      for j:=1 to size.y-2 do begin
        arr[n].x:=i; arr[n].y:=j; arr[n].z:=0;
        arr[n+1].x:=i; arr[n+1].y:=j; arr[n].z:=1;
        inc(n,2);
      end;
    shuffle;
  end;

procedure TCryst.Execute;
var m,x,y,z,sx,sy,n,n2:byte; k:real; i,j,ii:longint;
begin
  repeat  Randomize;
    ii:=(size.x-2)*(size.y-2)*2;
    inc(time,periods*2);
    for j:=1 to periods do begin
      shuffle;
      for i:=0 to ii-1 do begin
        if terminated then exit;
        x:=randar[i].x{random(size.x-2)+1};
        y:=randar[i].y{random(size.y-2)+1};
        z:=randar[i].z{random(2)};
        k:=random;
        if z=0 then begin
          sx:=0; sy:=0;
          n:=map[x,y];
          if n<=map[x+1,y] then sx:=1;
          if n<=map[x-1,y] then sx:=sx+1;
          if n<=map[x,y+1] then sy:=1;
          if n<=map[x,y-1] then sy:=sy+1;
          if k<veri[sx,sy] then map[x,y]:=n-1;
          end
        else begin
        n:=map[x,y];  sx:=0; sy:=0;
          if n<map[x+1,y] then sx:=1;
          if n<map[x-1,y] then sx:=sx+1;
          if n<map[x,y+1] then sy:=1;
          if n<map[x,y-1] then sy:=sy+1; n2:=5-sx-sy;
        if k<exp(-(n2-1)*fx+(n2-3)*dh/3+(6-n2)*dm/3)
           {verp} then map[x,y]:=n+1;end;
      end;
    end;
    m:=map[1,1];
    if m<map[1,size.y-2] then m:=map[1,size.y-2];
    if m<map[size.x-2,size.y-2] then m:=map[size.x-2,size.y-2];
    if m<map[size.x-2,1] then m:=map[size.x-2,1];


    map[1,1]:=m; map[1,size.y-2]:=m; map[size.x-2,1]:=m; map[size.x-2,size.y-2]:=m;
    restore_l(www-map[1,1]);

    for i:=0 to size.x-1 do begin
     map[i,0]:=map[i,size.y-2];
     map[i,size.y-1]:=map[i,1]; end;

      for j:=0 to size.y-1 do begin
      map[0,j]:=map[size.x-2,j];
     map[size.y-1,j]:=map[1,j]; end;

  until terminated;
end;

function TCryst.rate:cardinal;
  var i,j:byte; s:cardinal;
  begin
    s:=0;
    for i:=1 to size.x-2 do
      for j:=1 to size.y-2 do
       s:=s+map[i,j];
    rate:=s;
  end;

procedure TCryst.restore_l(n:integer);
  var i,j:byte;
  begin
    for i:=1 to size.x-2 do
      for j:=1 to size.y-2 do
        map[i,j]:=map[i,j]+n;
    shrate:=shrate-n;
  end;

procedure TCryst.ShutDown;
  begin
     shrate:=0;
     avbtime:=time;
     avbrate:=rate;
     if ProtWr then CloseProt;
  end;

procedure TCryst.show;
  var i,j:byte;
      x1,x2,y1,y2:integer;
      z:longint;
  begin
    canv.Lock;
    canv.Pen.Color:=clBlack;
    for i:=1 to size.x-2 do
      for j:=1 to size.y-2 do begin
        x1:=i*vis.x; x2:=x1+vis.x;
        y1:=j*vis.x; y2:=y1+vis.x;
        z:=(map[i,j]+shrate);
        if z>=0 then z:=z mod 8 else z:=8-(-z mod 8);
        canv.Brush.Color:=vis.paleter[z];
        canv.fillRect(rect(x1,y1,x2,y2));
        if map[i,j]<>map[i-1,j] then begin canv.MoveTo(x1,y1); canv.LineTo(x1,y2) end;
        if map[i,j]<>map[i,j-1] then begin canv.MoveTo(x1,y1); canv.LineTo(x2,y1) end;
      end;
    canv.unLock;
  end;



end.
