unit main_cr_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Buttons, MPlayer, Grids;

type
  Tmain_cr_f = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ScrollBox1: TScrollBox;
    PaintBox1: TPaintBox;
    bt_ss: TButton;
    ed_fx: TEdit;
    ed_dm: TEdit;
    bt_fdm: TButton;
    ed_x: TEdit;
    ed_y: TEdit;
    bt_xy: TButton;
    bt_save: TSpeedButton;
    bt_load: TSpeedButton;
    bt_clear: TSpeedButton;
    CheckBox1: TCheckBox;
    l_time: TLabel;
    l_vel: TLabel;
    l_area: TLabel;
    l_leng: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    l_inds: TLabel;
    l_indp: TLabel;
    bt_prot: TSpeedButton;
    t_params: TTimer;
    t_prot: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    l_avtim: TLabel;
    Label9: TLabel;
    ed_prtim: TEdit;
    l_countpr: TLabel;
    Timer1: TTimer;
    SpeedButton4: TSpeedButton;
    Label4: TLabel;
    Label10: TLabel;
    ed_fy: TEdit;
    ed_fz: TEdit;
    runauto_bt: TButton;
    Label11: TLabel;
    ed_nump: TEdit;
    procedure bt_saveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bt_loadClick(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure bt_fdmClick(Sender: TObject);
    procedure bt_clearClick(Sender: TObject);
    procedure bt_xyClick(Sender: TObject);
    procedure bt_ssClick(Sender: TObject);
    procedure t_paramsTimer(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure ed_fxChange(Sender: TObject);
    procedure ed_xChange(Sender: TObject);
    procedure bt_protClick(Sender: TObject);
    procedure t_protTimer(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure runauto_btClick(Sender: TObject);
  private
    procedure setautoparams;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  main_cr_f: Tmain_cr_f;

implementation

{$R *.DFM}

uses cryst_u;

var cryst:Tcryst; nnn:cardinal;
    auto:record run:boolean; f:text; numpoint,interv:integer; adr:string; end;

procedure Tmain_cr_f.bt_saveClick(Sender: TObject);
begin
  cryst.save;
end;

procedure Tmain_cr_f.FormCreate(Sender: TObject);
begin
  cryst:=Tcryst.create;
  auto.run:=false;
end;

procedure Tmain_cr_f.bt_loadClick(Sender: TObject);
begin
  if opendialog1.Execute then
    cryst.Load(opendialog1.filename);
end;

procedure Tmain_cr_f.TabSheet2Show(Sender: TObject);
begin
  ed_fx.Text:=floattostr(cryst.fx);
  ed_fy.Text:=floattostr(cryst.fy);
  ed_fz.Text:=floattostr(cryst.fz);
  ed_dm.Text:=floattostr(cryst.dm);
  ed_x.Text:=inttostr(cryst.size.x);
  ed_y.Text:=inttostr(cryst.size.y);
  ed_prtim.Text:=inttostr(auto.interv);
  ed_nump.Text:=inttostr(auto.numpoint);
end;

procedure Tmain_cr_f.bt_fdmClick(Sender: TObject);
begin
  cryst.fx:=strtofloat(ed_fx.text);
  cryst.fy:=strtofloat(ed_fy.text);
  cryst.fz:=strtofloat(ed_fz.text);
  cryst.dm:=strtofloat(ed_dm.text);
  cryst.Recount;
  cryst.ShutDown;
  t_prot.enabled:=false;
  bt_fdm.Caption:='!';
  l_indp.Caption:='-';
end;

procedure Tmain_cr_f.bt_clearClick(Sender: TObject);
begin
  cryst.ShutDown;
  cryst.avaragemap;
  t_prot.enabled:=false;
  l_indp.Caption:='-';
end;

procedure Tmain_cr_f.bt_xyClick(Sender: TObject);
begin
  cryst.size.x:=strtoint(ed_x.text);
  cryst.size.y:=strtoint(ed_y.text);
  cryst.PrepearCr;
  cryst.ShutDown;
  t_prot.enabled:=false;
  bt_xy.Caption:='!';
  l_indp.Caption:='-';
end;

procedure Tmain_cr_f.bt_ssClick(Sender: TObject);
begin
  if cryst.Suspended then l_inds.Caption:='+'
  else l_inds.Caption:='-';
  cryst.Suspended:=not cryst.Suspended;
end;

procedure Tmain_cr_f.t_paramsTimer(Sender: TObject);
var v:real; dt:cardinal; s:integer;
begin
  l_time.Caption:=inttostr(cryst.time);
  with cryst do
    dt:=time-avbtime;
  l_avtim.Caption:=inttostr(dt);
  if dt>0 then
    with cryst do begin
      s:=size.x*size.y;
      v:=(Rate/s+shrate-avbrate/s)/(time-avbtime);
{}      avaragemap;
    end
  else v:=0;
  l_vel.Caption:=floattostr(v);
end;

procedure Tmain_cr_f.SpeedButton4Click(Sender: TObject);
begin
  cryst.Suspend;
  cryst.canv:=paintbox1.Canvas;
  cryst.show;
  cryst.Resume;
end;

procedure Tmain_cr_f.ed_fxChange(Sender: TObject);
begin
  bt_fdm.Caption:='...';
end;

procedure Tmain_cr_f.ed_xChange(Sender: TObject);
begin
  bt_xy.Caption:='...';
end;

procedure Tmain_cr_f.bt_protClick(Sender: TObject);
begin
  if not cryst.ProtWr then begin
    cryst.BegPrF:=cryst.max-5;
    cryst.PrepProt;
    t_prot.Interval:=strtoint(ed_prtim.text);
    auto.numpoint:=strtoint(ed_nump.text);
    nnn:=0;
    t_prot.Enabled:=true;
    l_indp.Caption:='+';
  end;
end;

procedure Tmain_cr_f.t_protTimer(Sender: TObject);
begin
  inc(nnn);
  if nnn>auto.numpoint then
    if auto.run then begin
      cryst.Save;
      setautoparams;
    end
    else begin
      t_prot.enabled:=false;
      l_indp.Caption:='-';
    end;
  cryst.ProtWrit;
  l_countpr.Caption:=inttostr(nnn);
end;
         procedure Tmain_cr_f.PaintBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var xx,yy,n,l:integer; cl:Tcluster;
begin
  xx:=x div cryst.vis.x; yy:=y div cryst.vis.x;
  if (xx<cryst.size.x) and(yy<cryst.size.y) then begin
    n:=cryst.map[xx,yy]+cryst.shrate;
    cryst.cluster(n,cl);
    n:=cl[0]+cl[1]+cl[2]+cl[3]+cl[4];
    l:=cl[1]+2*cl[2]+3*cl[3]+cl[4]*4;
    l_area.Caption:=inttostr(n);
    l_leng.Caption:=inttostr(l);
  end;
end;
{procedure Tmain_cr_f.PaintBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var xx,yy,n:integer; cl:Tcluster; e:real;
begin
  xx:=x div cryst.vis.x; yy:=y div cryst.vis.x;
  if (xx<cryst.size.x) and(yy<cryst.size.y) then begin
    n:=cryst.map[xx,yy]+cryst.shrate;
    cryst.cluster(n,cl);
    n:=cl.s;
    e:=cl.x*cryst.fx+cl.y*cryst.fy;
    l_area.Caption:=inttostr(n);
    l_leng.Caption:=floattostr(e);
  end;
end;}

procedure Tmain_cr_f.Timer1Timer(Sender: TObject);
begin
  randomize;
end;




procedure Tmain_cr_f.setautoparams;
var s:string;
    n:integer;
begin
  if not eof(auto.f) then begin
    readln(auto.f,s);
    n:=pos('|',s);
    auto.adr:=copy(s,1,n-1);
    delete(s,1,n);
    n:=pos('|',s);
    auto.numpoint:=strtoint(copy(s,1,n-1));
    delete(s,1,n);
    auto.interv:=strtoint(s);
    t_prot.Interval:=auto.interv;
    cryst.Load(auto.adr+'/main.cry');
    ed_prtim.Text:=inttostr(auto.interv);
    ed_nump.Text:=inttostr(auto.numpoint);
    nnn:=0;
    cryst.BegPrF:=cryst.max-5;
    cryst.PrepProt;
    l_indp.Caption:='+';
  end
  else begin
    auto.run:=false;
    runauto_bt.Caption:='Start of automat';
    closefile(auto.f);
    t_prot.Enabled:=false;
    cryst.Suspend;
  end;
end;

procedure Tmain_cr_f.runauto_btClick(Sender: TObject);
begin
  auto.run:=not auto.run;
  t_prot.Enabled:=false;
  if auto.run then begin
    runauto_bt.Caption:='Stop of automat';
    assignfile(auto.f,'c:\automat.txt');
    reset(auto.f);
    setautoparams;
    tabsheet2.Show;
    t_prot.Enabled:=true;
  end
  else begin
    runauto_bt.Caption:='Start of automat';
    l_indp.Caption:='+';
    closefile(auto.f);
  end;
end;


end.
