﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication3
{
    public partial class Form1 : Form
    {

        const double scale = 2.98, imax = 17 /*the number of nodes*/, dx = 0.04/*dx/bd*/, 
            betha = 50.0 /*cm/s*/, D = 3e-5 /*cm^2/s*/, GT =/*232*/60 /*K/cm*/, nu = 2.5 /*V/Vcr*/, Pe = 0.3;
        double[] C = new double[(int)imax + 2];   //Concentrations of  main component
        double[] cb = new double[(int)imax + 2];  //New concentrations of  main component
        double[] x = new double[(int)imax + 2];
        double V, dt, ko, ck, ce, bd, d2c, xf, vf, dc, time, ml,
               kr, tf, vf0, y0, nh2, rb, T0, Te, dxx, cx, D_bez, cbb; // vf0 -velocity of moving
        // D_bez=D/bd/bd;   T0=T_liqudus(C0); Te(C[x=x_front]
        int i, j, k; string s, st;

        public void line(PaintEventArgs e, int x1, int y1, int x2, int y2)
        {
            e.Graphics.DrawLine(new Pen(Color.Black), x1, y1, x2, y2);
        }

        public void line(PaintEventArgs e, double x1, double y1, double x2, double y2)
        {
            e.Graphics.DrawLine(new Pen(Color.Black), (int)x1, (int)y1, (int)x2, (int)y2);
        }

        public void line(PaintEventArgs e, double x1, double y1, double x2, double y2, Color Col)
        {
            e.Graphics.DrawLine(new Pen(Col), (int)x1, (int)y1, (int)x2, (int)y2);
        }


        public void str(double d, string s)
        {
            st = d.ToString("0.00000");  // format of printing
        }


        public void Drawing(PaintEventArgs e)
        {
            int i = 1; double x1 = 0, x2 = 0, y1 = 0, y2 = 0;
            x1 = 40 + Math.Round(xf * scale); y1 = 330;

            while (/*x1 < 640 && x2 < 640 && y1 < 480 && y2 < 480 && */(i <= imax))
            {
                x2 = 40 + Math.Round(x[i] * scale); y2 = 330 - Math.Round((1 - C[i]) * 300 * 10);
                line(e, x1, y1, x2, y2);
                x1 = x2; y1 = y2;
                i++;
            }
        }

        public void Drawing(PaintEventArgs e, Color Col)  //of the concentration distribution
        {
            int i = 1; double x1 = 0, x2 = 0, y1 = 0, y2 = 0;
            x1 = 40 + Math.Round(xf * scale); y1 = 330;

            while (/*x1 < 640 && x2 < 640 && y1 < 480 && y2 < 480 && */(i < imax))
            {
                x2 = 40 + Math.Round(x[i] * scale); y2 = 330 - Math.Round((1 - C[i]) * 300 * 10);
                line(e, x1, y1, x2, y2, Col);
                x1 = x2; y1 = y2;
                i++;
            }
        }
        public void Theoretic()
        {
            //var i:integer;
            {

                for (int i = 1; i <= imax; i++)
               C[i] = 1 - 0.002 * (1 + (1 - ko) / ko * Math.Exp(-vf0 * bd * (x[i] - xf) / D));
            };
        }



        public void outtextxy(PaintEventArgs c, int x, int y, string s)
        {
            c.Graphics.DrawString(s, new Font("Arial", 10), new SolidBrush(Color.Black), (float)x, (float)y);
        }

        public void outtextxy(PaintEventArgs c, double x, double y, string s)
        {
            c.Graphics.DrawString(s, new Font("Arial", 10), new SolidBrush(Color.Black), (float)x, (float)y);
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e) //MAIN
        {
            ko = 0.1; time = 0;
            line(e, 40, 330, 620, 330); line(e, 40, 330, 40, 30);
            line(e, 35, 180, 45, 180); line(e, 35, 30, 45, 30);
            line(e, 140, 335, 140, 330);
            line(e, 240, 335, 240, 330);
            line(e, 340, 335, 340, 330);
            line(e, 440, 335, 440, 330);
            line(e, 540, 335, 540, 330);
            outtextxy(e, 25, 10, "C_B"); outtextxy(e, 15, 33, "0.1");
            outtextxy(e, 10, 183, "0.05"); outtextxy(e, 138, 340, "2");
            outtextxy(e, 238, 340, "4"); outtextxy(e, 438, 340, "8");
            outtextxy(e, 338, 340, "6"); outtextxy(e, 538, 340, "10 bd");
            outtextxy(e, 620, 339, "x ");

            y0 = 0.0; xf = 0;
            nh2 = (imax - 2) * (imax - 1);
            rb = y0 + dx + nh2 * 0.5 * dx;   //Calculating area in units bd
            T0 = 200.4;

            ml = 0.003;
            vf0 = nu * GT * D * ml / 0.02;      // The velocity of pulling
            bd = D / vf0;                       //The diffusion lenght
            D_bez = D / (bd * bd);

            str(betha, st); outtextxy(e, 60, 40, "betha(cm/s)=" + st);
            str(vf0, st); outtextxy(e, 60, 60, "vf0(cm/s)=" + st);
            str(bd, st); outtextxy(e, 60, 80, "bd(cm)=" + st);
            str(nu, st); outtextxy(e, 60, 120, "nu=" + st);
            str(GT, st); outtextxy(e, 60, 140, "GT(K/s)=" + st); //the temperature gradient
            vf = vf0 / bd;
            dt = 0.2 * dx * dx / D_bez; 
            time = 0;
            for (i = 2; i <= imax; i++)
                C[i] = 0.998; C[1] = 0.998;     //The initial concentration distribution
            xf = 0; x[1] = xf; x[2] = xf + dx;  // rb=dx(imax-1)*imax/2
            for (i = 3; i <= imax; i++)
                x[i] = xf + dx + (rb - xf - dx) * (i - 2) * (i - 1) / nh2;   /*rb*(i-1)*i/imax/(imax-1)*/
            //Theoretic;     /*well initial distrbution*/
            Drawing(e);

            for (k = 1; k <= 12; k++)
            {
                for (j = 1; j <= 30000; j++)
                {
                    // tf = 200 - GT * vf0 * time + GT * xf * bd;
                    x[1] = xf; x[2] = xf + dx;
                    for (int i = 3; i <= imax; i++)
                        x[i] = xf + dx + (rb - xf - dx) * (i - 2) * (i - 1) / nh2;

                    for (int i = 2; i <= imax - 1; i++)
                    {
                        dxx = x[i] - x[i - 1];      //The distant between nodes
                        cx = C[i] + (C[i + 1] - C[i]) / (x[i + 1] - x[i]) * dxx;
                        d2c = (cx - 2 * C[i] + C[i - 1]) / dxx / dxx;   //The second deriviative
                        dc = D_bez * d2c * dt + vf * dt * (C[i + 1] - C[i]) / (x[i + 1] - x[i]);  /**bd/bd*/
                        cb[i] = C[i] + dc;      //New concentrations
                    }
                    tf = T0 - GT * vf0 * time + GT * xf * bd;       //The front temperature
                    time = time + dt;

                    ck = 1 - ko * (1 - C[1]);
                    ce = 0.998 - (T0 - tf) * ml;  //Equilibrium concentration (tf)
    
                    vf = betha * (C[1] - ce) / ce / bd;
                 double cb1 = cb[2] - vf * dx * (ck - C[1]) / D_bez;
               //New concentration near the interface
                    for (int i = 1; i <= 20; i++)
                    {
                        if (Math.Abs(cb1 - C[1]) < 2e-5) break; //Limitation of a change
                        cb1 = 0.25 * cb1 + 0.75 * C[1];
                    };
                   

                    vf = betha * (cb1 - ce) / ce / bd;      //more exact velocity

                    cb[1] = cb[2] - vf * dx * (ck - cb1) / D_bez; //more exact new interface concentration  

                    for (int i = 1; i < 10; i++)
                    {
                        if (Math.Abs(cb[1] - cb1) < 6e-6) break; //Limitation of a change
                        cb[1] = 0.25 * cb[1] + 0.75 * cb1;
                    };

                    vf = betha * (cb[1] - ce) / ce / bd;        //more exact velocity
                    xf = xf + vf * dt; /*New interface position*/ rb = rb + vf * dt;        

                    for (int i = 1; i <= imax - 1; i++) C[i] = cb[i];

                };



                if ((k == 1) || (k % 2 == 0))
                { //Information on time (min) and surface supersatiration
                    str(time / 60, st);
                    Drawing(e);
                    outtextxy(e, 20 + Math.Round(xf * scale), 240 - 9 * k, st + "min"); //"t=" + 
                    str((C[1] - ce) / ce, st);
                    e.Graphics.FillRectangle(new SolidBrush(Color.Wheat), 59, 99, 230, 15);
                    outtextxy(e, 60, 100, "(ce-c1)/ce=" + st);
                };

                if (k == 10)        // Drawing of equilibrium concentration ce(x)
                {
                    for (int i = 1; i <= imax - 1; i++)
                    {
                        cb[i] = C[i];
                        C[i] = C[1] + ml * GT * (x[i] - x[1]) * bd;
                    }
                    Drawing(e, Color.Blue);
                    for (int i = 1; i <= imax - 1; i++) C[i] = cb[i];
                }
             }
                Theoretic();    // Calculation of the theoretical cB(x) distribution
                Drawing(e, Color.Red); // Drawing of the theoretical cB(x) distribution                       
        }
    }
}
