﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MicroDaemon
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public int IntMax(int[] a)
        {
            int max;
            max = Math.Abs(a[0]);
            for (int i = 1; i < a.Length; i++)
            {
                if (Math.Abs(a[i]) > max)
                {
                    max = Math.Abs(a[i]);
                }
            }
            return max;
        }

        public int IntMin(int[] array)
        {
            int min;
            min = Math.Abs(array[0]);
            for (int i = 1; i < array.Length; i++)
            {
                if (Math.Abs(array[i]) < min)
                {
                    min = Math.Abs(array[i]);
                }
            }
            return min;
        }

        public double Max(double[] array)
        {
            double max;
            max = Math.Abs(array[0]);
            for (int i = 1; i < array.Length; i++)
            {
                if (Math.Abs(array[i])>max)
                {
                    max = Math.Abs(array[i]);
                }
            }
            return max;
        }

        public double Min(double[] array)
        {
            double min;
            min = Math.Abs(array[0]);
            for (int i = 1; i < array.Length; i++)
            {
                if (Math.Abs(array[i]) < min)
                {
                    min = Math.Abs(array[i]);
                }
            }
            return min;
        }
        private void button1_Click(object sender, EventArgs e)
        {
            int N = Convert.ToInt32(particlesN.Text);
            double E_sys = Convert.ToDouble(sysE*N.Text);
            double E_i = E_sys / N;
            double dvmax = Convert.ToDouble(daemonEmax.Text);
            int attempts = Convert.ToInt32(daemonAttempts.Text);
            double E_d = 0;
            double vtot = 0;
            double norm = 1 / Convert.ToDouble(N * attempts);
            double vcum = 0;
            double escum = 0;
            double edcum = 0;
            double[] v = new double[N];
            for (int i = 0; i < N; i++)
            {
                v[i] = Math.Sqrt(2 * E_i);
                vtot += v[i];
            }

            Random rnd = new Random();
            int a = 0;
            for (int j = 0; j < attempts; j++)
            {
                for (int i = 0; i < N; i++)
                {
                    double dv = dvmax * (2 * rnd.NextDouble() - 1);
                    int ipart = (int)rnd.Next(N);
                    double vtrial = v[ipart] + dv;
                    double  dE = 0.5 * (Math.Pow(vtrial, 2) - Math.Pow(v[ipart], 2));
                    if (dE <= E_d)
                    {
                        v[ipart] = vtrial;
                        vtot += dv;
                        a++;
                        E_d -= dE;
                        E_sys += dE;
                    }
                    edcum += E_d;
                    escum += E_sys;
                    vcum += vtot;
                }
            }
            double edave = edcum * norm;
            double esave = escum * norm / (double)N;
            double vave = vcum * norm / (double)N;
            double accept = a * norm;
            label12.Text = Math.Round(edave, 5).ToString();
            label13.Text = Math.Round(esave, 5).ToString();
            label14.Text = Math.Round(vave, 5).ToString();
            label15.Text = Math.Round(accept, 5).ToString();

            double[] E = new double[N];
            for (int i = 0; i < N; i++)
            {
                E[i] = Math.Pow(v[i], 2) / 2;
            }

            int steps = 20;
            int[] items = HistogrmmData(v, steps);
            DrawHistogram(items, v, steps, pictureBox1, "n(v)");
            int[] Eitems = HistogrmmData(E, steps);
            DrawHistogram(Eitems, E, steps, pictureBox2, "n(E)");
        }

        public int[] HistogrmmData(double[] a, int steps)
        {
            int[] items = new int[steps];
            double amax = Max(a);
            double amin = Min(a);

            int c = 0;
            double dh = (amax - amin) / (double)steps;
            double t = amin;
            while (c < steps)
            {
                for (int i = 0; i < a.Length; i++)
                {
                    if ((a[i] > t) && (a[i] < t + dh))
                    {
                        items[c]++;
                    }
                }
                c++;
                t += dh;
            }

            return items;
        }
        public void DrawHistogram(int[] items, double[] a, int steps, PictureBox pb, string s)
        {
            int h = pb.Height;
            int w = pb.Width;
            double vmax = Max(a);
            double vmin = Min(a);
            double dh = (vmax - vmin) / (double)steps;
            int imax = IntMax(items);
            int imin = IntMin(items);
            double scaleY = (h - 20) / (double)(imax - imin);
            double scaleX = (w - 10) / (vmax - vmin);

            Bitmap bmp = new Bitmap(w, h);
            Graphics canvas = Graphics.FromImage(bmp);

            for (int i = 0; i < steps; i++)
            {
                int rx = Convert.ToInt32(dh * scaleX * i + 10);
                int rw = Convert.ToInt32(dh * scaleX);
                int rh = Convert.ToInt32(scaleY * items[i]);

                canvas.FillRectangle(Brushes.Red, rx, h - rh, rw, h);
                canvas.DrawRectangle(Pens.Black, rx, h - rh, rw, h);
                canvas.DrawString(s, new Font("Tahoma", 10), Brushes.Black, w - 50, 20);
                canvas.DrawString(items[i].ToString(), new Font("Tahoma", 8), Brushes.Black, Convert.ToInt32(dh * scaleX * i + 7), h - rh - 15);
            }

            Graphics pb1 = pb.CreateGraphics();
            pb1.Clear(Color.White);
            pb1.DrawImage(bmp, 0, 0);
            pb1.Dispose();
            canvas.Dispose();
            bmp.Dispose();
        }
        
    }
}
