unit UMicro1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, TeEngine, Series, TeeProcs, Chart;

type
  TMicrodemon = class(TForm)
    Label1: TLabel;
    Lable4: TLabel;
    Lable5: TLabel;
    Lable6: TLabel;
    Lable7: TLabel;
    Lable8: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit3: TEdit;
    Edit10: TEdit;
    Chart1: TChart;
    Series1: TBarSeries;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Panel2: TPanel;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    Label4: TLabel;
    Timer1: TTimer;
    Memo1: TMemo;
    BitBtn3: TBitBtn;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn1Enter(Sender: TObject);
    procedure BitBtn1Exit(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;
const
  Na = 6.02e23;
var
  Microdemon: TMicrodemon;
  N,n_trial:integer;
  dE_max,M_mol,edemon,esystem, vtot,dvmax, v0, averages, demsam: real;
  vel:array[1..10000]of real;
  e: array[1..10000]of real;
  edmn: array[1..10000] of real;
  GlobFlag:boolean;

implementation

{$R *.dfm}

procedure TMicrodemon.BitBtn2Click(Sender: TObject);
begin
Series1.Clear;
end;

procedure Init;{calculations of v0, demon energy, highest velocity, initial energy of moleculs}
var i:integer;
    e0:real;
begin
demsam:=0;
edemon:=1e-20;
dvmax:=100;
E0:= esystem/N;
For i:=1 to N do
E[i]:=E0;
v0:=sqrt(2*E0*Na/M_mol);
Microdemon.Edit3.Text:=FloatToStr(v0);
end;

Procedure changes;   {a change of energy of the system and of the demon}
var
dE,vtrial,esystem:real;
i,j,ipart:integer;
begin
for j:=1 to N_trial do
for i:=1 to N do
begin
dE:=random*dE_max;
if (Microdemon.RadioButton2.Checked) then ipart:= trunc(random*N+1)
else ipart:=i;
if dE<=edemon then
begin
E[ipart]:=E[ipart]+dE;
esystem:=esystem+dE;
edemon:=edemon-dE;
end
else if dE<=E[ipart] then
begin
esystem:=esystem-dE;
E[ipart]:=E[ipart]-dE;
edemon:=edemon+dE;
end;
if j = N_trial then
edmn[ipart]:=edemon;
demsam:=demsam+edemon;
end;
end;

Procedure gistograma;   {distribution of particles on velocities}
var
j,i,dummy:integer;
y:array[1..40]of integer;
k,vmax:real;
begin
Microdemon.Chart1.BottomAxis.Title.Caption := 'v, m/s';
Microdemon.Chart1.LeftAxis.Title.Caption := 'n(v)';
vmax:=0;
for dummy:=1 to N do
if vel[dummy]>vmax then vmax:=vel[dummy];
for j:=1 to 30 do
y[j]:=0;
for j:=1 to 30 do
for i:=1 to N do
if round(30*vel[i]/vmax)=j then
inc(y[j]);
for j:=1 to 30 do
Microdemon.Series1.AddXY(j*vmax/30,y[j],'',$0000FF)
end;

Procedure gistogramaE;    {distribution of particles on energies}
var
j,i,dummy:integer;
y:array[1..40]of integer;
k,Emax:real;
begin
Microdemon.Chart1.BottomAxis.Title.Caption := 'E, 1e-20 J';
Microdemon.Chart1.LeftAxis.Title.Caption := 'n(E)';

Emax:=0;
for dummy:=1 to N do
if edmn[dummy]>emax then emax:=e[dummy];
for j:=1 to 30 do
y[j]:=0;
for j:=1 to 30 do
for i:=1 to N do
if round(30*edmn[i]/emax)=j then
inc(y[j]);
for j:=1 to 30 do
Microdemon.Series1.AddXY(j*emax*1e20/30,y[j],'',$0000FF)
end;



 Procedure gistogramaDemon; {distribution of demons on energies}
 var
 j,i,dummy:integer;
 y :array[1..40]of integer;
 k,EDmax:real;
 begin
 Microdemon.Chart1.BottomAxis.Title.Caption := 'n ';
 Microdemon.Chart1.LeftAxis.Title.Caption := 'EDemon(n), J';
 EDmax:=0;
 for dummy:=1 to N do
 if e[dummy]>eDmax then eDmax:=e[dummy];
 for j:=1 to 30 do
 y[j]:=0;
 for j:=1 to 30 do
 for i:=1 to N do
 if round(30*e[i]/eDmax)=j then
 inc(y[j]);
 for j:=1 to 30 do
 Microdemon.Series1.AddXY(j*edmax/30,y[j],'',$0000FF)

 end;


procedure TMicrodemon.BitBtn1Click(Sender: TObject); {checking of input values}
var
edemon,vtot,dvmax,v0,averages:real;
i,j,il:integer;
begin
demsam:=0;
if GlobFlag then
begin
if edit1.text=' 'then
showmessage('Input the value!')
else N:=strtoint(Microdemon.Edit1.text);
if edit4.text=' 'then
showmessage(''Input the value!')
else Esystem:=strtofloat(Microdemon.Edit4.text);
if edit6.text=' 'then
showmessage('Vvedite znachenie!')
else dE_max:=strtofloat(Microdemon.Edit6.text);
if edit7.text=' 'then
showmessage('Vvedite znachenie!')
else M_mol:=strtofloat(Microdemon.Edit7.text);
if edit8.text=' 'then
showmessage(''Input the value!')
else n_trial:=strtoint(Microdemon.Edit8.text);

Series1.Clear; 
randomize;
Init;
changes;
averages:=demsam/N/N_trial;
For i:=1 to N do
vel[i]:=sqrt(2*E[i]*Na/M_mol);
 edit3.text:=FloatToStr(averages);
 edit10.text:=FloatToStr(vel[5]);
 { }
if RadioButton3.Checked then gistograma;
if RadioButton4.Checked then gistogramaE;
if RadioButton5.Checked then gistogramaDemon;
end;
end;
procedure TMicrodemon.BitBtn1Enter(Sender: TObject);
begin
GlobFlag:=true;
end;

procedure TMicrodemon.BitBtn1Exit(Sender: TObject);
begin
GlobFlag:=false;
end;

procedure TMicrodemon.Timer1Timer(Sender: TObject); {The title}
var a: string;
begin
a:= ' Microdemon salutes for you!!!';
if label4.GetTextLen*11 < Label4.width
then Microdemon.label4.caption:=' ' + Microdemon.label4.caption
else Microdemon.label4.caption := a;
Label4.Font.Color:=  RGB(random(255),random(255),random(255));
end;



procedure TMicrodemon.BitBtn3Click(Sender: TObject);{}
begin
memo1.Text:='averages isthe middle value of system energy;  vel[5] is the velocity of certain molecule;  N is the number of molecules;  Esystem is the system energy;  Na is Avogadro constant;  dE_Max is the maximum energy portion;  M_mol is the mol mass;  N_trial is the trial number.'
end;

end.


