﻿namespace Sphera
{
    using System;

    internal class Program
    {
        private const double D = 3E-05; //{cm^2/s}
        private const double c01 = 0.9;
        private const double ce = 0.8;
        private const int ck = 1;
        private const double bk = 0.1 * D / 3e-8 * 1e-3;
        private const double filtr = 0.0001;
        private const int jmax = 16;
        private const double rb = 0.2;
        private const int tmax = 30000;

        private static void Main(string[] args)
        {
            double[] r = new double[0x11];
            double[] c = new double[0x11];
            double[] c_new = new double[0x11];
            Console.WriteLine("Начало");
            r[1] = 0.002;
            double t = 0; c[1] = 0.81; c[2] = 0.83; c[3] = 0.86;
            int nh2 = (jmax - 1) * jmax; double a = 0.0002;
            double dr = (rb - r[1]) * 2 / nh2;
            for (int j = 4; j <= jmax; j++) c[j] = c01;
            for (int j = 2; j <= jmax; j++) r[j] = r[j - 1] + dr * (j - 1);  //rb=r[1]+nh2*0.5*br;}
            double v = bk * (c[1] - ce) / ce;
            double dt = a * dr * dr / D;
            for (int k = 1; k <= 3; k++)
                for (int i1 = 1; i1 <= tmax; i1++)
                {
                    //{main cycle in time}
                    if (i1 == 6000) a = a * 2; if (i1 == 2000) a = a * 2; if (i1 == 4000) a = a * 2;
                    double br = (rb - r[1]) * 2 / nh2;  //{dr=(R_kuv-r[1])/nh-1;}
                    dt = a * br * br / D;
                    for (int j = 2; j <= jmax - 1; j++)
                    {
                        //{koordinats of grid points }

                        r[j] = r[j - 1] + br * (j - 1);  //{r[j]=r[1]+(rb-r[1])*(j-1)*j/nh2;}
                        double brj = br * j + br * (j - 1);   //{(r[j+1]-r[j-1]);}
                        double Dcdr = (c[j + 1] - c[j - 1]) / brj;
                        double Dcdr2 = (c[j + 1] - c[j]) / (br * j);
                        double Dcdr1 = (c[j] - c[j - 1]) / (br * (j - 1));
                        double D2cd2r = (Dcdr2 - Dcdr1) * 2 / brj;

                        double drj = v * dt - v * dt * (j - 1) * j / nh2;  //{Change of r(j) za dt}
                        c_new[j] = c[j] + dt * D * (D2cd2r + 2 * Dcdr / r[j]) + Dcdr * drj;
                    }
                    c_new[1] = c[2] - v * (ck - c[1]) * br / D;
                    for (int i3 = 1; i3 <= 10; i3++)
                        if (((c_new[1] - c[1]) * (c_new[1] - c[1])) < filtr * filtr) break;
                        else c_new[1] = 0.75 * c[1] + 0.25 * c_new[1];
                    v = bk * (c_new[1] - ce) / ce;    //{rate of crystaL grows}
                    r[1] = r[1] + v * dt;
                    t = t + dt;
                    for (int j = 1; j <= jmax - 1; j++)
                        c[j] = c_new[j]; c[jmax] = c_new[jmax - 1];
                    if (i1 == 600)
                        Console.WriteLine("t = {0}, r_cr = {1}, c1 = {2}", t, r[1], c[1]);
                    if (i1 % 2000 == 0)
                        Console.WriteLine("t = {0}, r_cr = {1}, c1 = {2}", t, r[1], c[1]);
                }
            Console.WriteLine("  ");
            double S = 0;
            for (int j = 1; j <= jmax - 1; j++)
                S = S + 4 * 3.1415 * r[j] * r[j] * (r[j + 1] - r[j]) * (c01 - (c[j] + c[j + 1]) * 0.5);

            double Vr1 = 4 * (ck - c01) * 3.1415 * r[1] * r[1] * r[1] / 3;  //{1-Co=0.9}

            Console.WriteLine("r1={0},R={1}, s={2}", r[1], rb, S);
            Console.WriteLine(" R={0},Vr1={1}", rb, Vr1);
            Console.WriteLine("  ");
            for (int j = 1; j <= jmax; j++)
                Console.WriteLine("j = {0}, r1 = {1}, c[j] = {2}", j, r[j], c[j]);
            Console.WriteLine("t= {0} ", t); //{close (outfile);}
            Console.ReadKey();
        }
    }
}
